import os
import time
import re


class i2c_tool:

    def __init__(self) -> None:
        self.i2c_bus = 10

    def scan_i2c_bus(self, slave_addr):
        i2c_buses = []
        addr_string = re.split("x",hex(slave_addr))[1]
        bus = os.popen("ls /dev | grep i2c").read()
        bus_list = re.split("i2c-|\n", bus)
        for string in bus_list:
            if string >= '0' and string <'20':
                i2c_buses.append(string)
        for bus in i2c_buses:
            tmp = os.popen("i2cdetect -y %s"%bus).read()
            if tmp.find(addr_string) != -1:
                self.i2c_bus = bus
                break

        


    def write(self, slave_addr, register_addr, value):
        try:
            os.popen("i2cset -y %s %s %s %s"%(self.i2c_bus, str(slave_addr), str(register_addr),str(value)))
        except Exception as e:
            print(str(e))
            return False


    def read(self, slave_addr, register_addr):
        try:
            string = os.popen("i2cset -y %s %s %s"%(self.i2c_bus, str(slave_addr), str(register_addr))).read()
            return string
            
        except Exception as e:
            print(str(e))
            return False

    


i2c_tools = i2c_tool()